declare class Right<T> {
    readonly _value: T;
    private _tag;
    constructor(_value: T);
}
declare class Left {
    readonly _error: Error;
    private _tag;
    constructor(_error: Error);
}
export declare type Either<T> = Right<T> | Left;
export declare const right: <T>(value: T) => Either<T>;
export declare const left: <T>(error: Error) => Either<T>;
export declare const isRight: <T>(value: Either<T>) => boolean;
export declare const isLeft: <T>(value: Either<T>) => boolean;
export declare const withDefault: <T>(value: Either<T>, defaultValue: T) => T;
export declare const map: <A, B>(f: (a: A) => B, value: Either<A>) => Either<B>;
export declare const andThen: <A, B>(f: (a: A) => Either<B>, value: Either<A>) => Either<B>;
export declare const caseOf: <A, B>(caseof: {
    Right: (v: A) => B;
    Left: (err: Error) => B;
}, value: Either<A>) => B;
export declare const tryCatch: <A>(f: () => A, onError: (e: Error) => Error) => Either<A>;
export {};
